<?php

class ControllerModuleNewsletter2Go extends Controller
{

    /**
     * Test connection method
     */
    public function index()
    {
        if ($this->checkUser()) {
            $response = array('success' => true, 'message' => 'Success');
        } else {
            $response = array('success' => false, 'message' => 'User validation faild!');
        }

        $this->setResponse($response);
    }

    public function getCustomers()
    {
        $criteria = array();
        $criteria['offset'] = $this->request->get['offset'];
        $criteria['limit'] = $this->request->get['limit'];
        $criteria['subscribed'] = $this->request->get['subscribed'];

        if (!$this->checkUser()) {
            return $this->setResponse(array('success' => false, 'message' => 'User validation faild!'));
        }

        $response = array('success' => true, 'message' => 'Success');
        $this->load->model('module/newsletter2go');
        
        $result = $this->model_module_newsletter2go->getCustomers($criteria);
        $response['customers'] = $result['customers'];
        $response['total'] = $result['total'];
        
        $n = count($response['customers']);
        for ($i = 0; $i < $n; $i++) {
            $response['customers'][$i]['gender'] = null;
            $response['customers'][$i]['birthday'] = null;
        }

        $this->setResponse($response);
    }

    public function getProduct()
    {
        $id = $this->request->get['id'];
        $lang = $this->request->get['lang'];
        if (!$id || !$lang) {
            return $this->setResponse(array('success' => false, 'message' => 'Missing product parameters!'));
        }

        if (!$this->checkUser()) {
            return $this->setResponse(array('success' => false, 'message' => 'User validation faild!'));
        }

        $response = array('success' => true, 'message' => 'Success');
        $this->load->model('module/newsletter2go');
        $response['product'] = $this->model_module_newsletter2go->getProduct($id, $lang);

        $this->setResponse($response);
    }

    public function unsubscribeCustomer()
    {
        $email = $this->request->post['email'];

        if (!$email) {
            return $this->setResponse(array('success' => false, 'message' => 'Missing email parameter!'));
        }

        if (!$this->checkUser()) {
            return $this->setResponse(array('success' => false, 'message' => 'User validation faild!'));
        }

        $response = array('success' => true, 'message' => 'Success');
        $this->load->model('module/newsletter2go');
        $this->model_module_newsletter2go->unsubscribeByEmail($email);

        $this->setResponse($response);
    }

    protected function checkUser()
    {
        $username = $this->request->server['PHP_AUTH_USER'];
        $apikey = $this->request->server['PHP_AUTH_PW'];
        $this->load->model('module/newsletter2go');

        return $this->model_module_newsletter2go->validateUser($username, $apikey);
    }

    protected function setResponse($response)
    {
        $this->response->addHeader('Content-Type: application/json');
        $this->response->setOutput(json_encode($response));
    }
}
